// This file is part of LORM, a  C++ library for optimization on 
// Riemannian manifolds.
//
// Copyright (C) 2013 Manuel Gräf <m.graef@mathematik.tu-chemnitz.de>
//
// This source code form is subject to the terms of the Mozilla
// Public License v. 2.0. If a copy of the MPL was not distributed
// with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
#ifndef _SPHERE_TIMES_R_HPP_
#define _SPHERE_TIMES_R_HPP_

#include "../Manifold.hpp"

namespace LORM {

  namespace Sphere {
    
    /** \class SphereTimesR
     *
     *  \brief Implements the product of the d-dimensional sphere S^d with R as Manifold.
     *
     **/
    
    class SphereTimesR : public Manifold {
    public:
      /// Constructor. One must provide the dimension d of the manifold S^d times R.
      explicit SphereTimesR ( int d ) :
	Manifold ( "Sphere times R", d+1, d+2) {};
    };

  } // end namespace Sphere

} // end namespace LORM

#endif // _SPHERE_TIMES_R_HPP_
